SystemOrganization addCategory: #'Mason-MC1'!

MDJob subclass: #MDGetVersionJob
	instanceVariableNames: 'repository filename path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-MC1'!

!MDGetVersionJob methodsFor: 'accessing' stamp: 'cwp 9/13/2009 23:50'!
filename
	^ filename! !

!MDGetVersionJob methodsFor: 'accessing' stamp: 'cwp 9/13/2009 23:50'!
filename: anObject
	filename := anObject! !

!MDGetVersionJob methodsFor: 'accessing' stamp: 'cwp 9/13/2009 23:43'!
path
	^ path! !

!MDGetVersionJob methodsFor: 'accessing' stamp: 'cwp 9/13/2009 23:43'!
path: anObject
	path := anObject! !

!MDGetVersionJob methodsFor: 'accessing' stamp: 'cwp 9/1/2009 21:32'!
repository
	^ repository! !

!MDGetVersionJob methodsFor: 'accessing' stamp: 'cwp 9/1/2009 21:32'!
repository: anObject
	repository := anObject! !

!MDGetVersionJob methodsFor: 'dependencies' stamp: 'cwp 9/17/2009 21:58'!
requires
	^ Set with: path parent! !

!MDGetVersionJob methodsFor: 'running' stamp: 'cwp 9/13/2009 23:50'!
run
	| buffer out |
	buffer := ByteArray new: 1024.
	out := path asReference writeStream.
	[repository readStreamForFileNamed: filename do:
		[:in |
		in binary.
		[in atEnd] whileFalse:
			[buffer := in nextInto: buffer.
			out nextPutAll: buffer]]]
				ensure: [out close]! !

!MDGetVersionJob methodsFor: 'dependencies' stamp: 'cwp 9/14/2009 00:12'!
supplies
	^ Set with: path! !

!MDTargetCanvas methodsFor: '*mason-mc1-targets' stamp: 'cwp 9/15/2009 09:22'!
mc1RepositorySource: aRepository
	^ MDMc1RepositorySource for: aRepository! !

!MDTargetCanvas methodsFor: '*mason-mc1-targets' stamp: 'cwp 9/25/2009 09:58'!
monticello
	^ self addChild: MDMc1LoaderTarget new! !

!MDTargetCanvas methodsFor: '*mason-mc1-targets' stamp: 'cwp 9/15/2009 09:12'!
version
	^ self addChild: MDMc1VersionTarget new! !

Object subclass: #MDMc1LoadScript
	instanceVariableNames: 'target repositories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-MC1'!

!MDMc1LoadScript class methodsFor: 'as yet unclassified' stamp: 'cwp 9/25/2009 22:47'!
for: aTarget
	^ self new setTarget: aTarget! !

!MDMc1LoadScript methodsFor: 'writing' stamp: 'cwp 9/25/2009 14:50'!
creationTemplateFor: ea
	^ (ea asCreationTemplate copyWithout: Character cr)
		replaceAll: Character tab with: Character space! !

!MDMc1LoadScript methodsFor: 'accessing' stamp: 'cwp 9/25/2009 23:42'!
indexOfRepositoryFor: child
	self repositories doWithIndex: [:ea :index | child source repository = ea ifTrue: [^ index]].
	^ 0! !

!MDMc1LoadScript methodsFor: 'accessing' stamp: 'cwp 9/25/2009 14:54'!
repositories
	^ repositories ifNil:
		[repositories := (target children 
							inject: Set new
							into: [:set :ea | set add: ea source repository. set])
								asArray sort: [:a :b | a description <= b description]]! !

!MDMc1LoadScript methodsFor: 'writing' stamp: 'cwp 9/25/2009 22:53'!
script
	^ String streamContents: [:out | self writeLoadScriptOn: out]! !

!MDMc1LoadScript methodsFor: 'initialize-release' stamp: 'cwp 9/25/2009 22:48'!
setTarget: aTarget
	target := aTarget! !

!MDMc1LoadScript methodsFor: 'writing' stamp: 'cwp 9/26/2009 00:03'!
writeAdditionOn: aStream 
	target children doWithIndex: 
		[ :child :index | 
		aStream
			nextPutAll: '(versions at: ';
			print: index;
			nextPutAll: ') withAllDependenciesDo: ';
			nextPutAll: '[:v | v workingCopy repositoryGroup addRepository: (repositories at: ';
			print: (self indexOfRepositoryFor: child);
			nextPutAll: ')].';
			cr ]! !

!MDMc1LoadScript methodsFor: 'writing' stamp: 'cwp 9/26/2009 00:02'!
writeLoadOn: aStream
	aStream 
		nextPutAll: 'MCVersionLoader new';
		cr.
	(1 to: target children size) do:
		[:index |
		aStream 
			tab;
			nextPutAll: 'addVersion: (versions at: ';
			print: index;
			nextPutAll: ');';
			cr].
	aStream 
		tab;
		nextPutAll: 'load.';
		cr;
		cr! !

!MDMc1LoadScript methodsFor: 'writing' stamp: 'cwp 9/26/2009 00:03'!
writeLoadScriptOn: aStream 
	self writeTempsOn: aStream.
	self writeRepositoriesOn: aStream.
	self writeVersionsOn: aStream.
	self writeLoadOn: aStream.
	self writeAdditionOn: aStream.! !

!MDMc1LoadScript methodsFor: 'writing' stamp: 'cwp 9/25/2009 14:50'!
writeRepositoriesOn: aStream
	| repositories |
	repositories := self repositories.
	aStream 
		nextPutAll: 'repositories := Array new: ';
		print: repositories size;
		nextPut: $.;
		cr.
	repositories doWithIndex: 
		[:ea :i | 
		aStream
			nextPutAll: 'repositories at: ';
			print: i;
			nextPutAll: ' put: (';
			nextPutAll: (self creationTemplateFor: ea);
			nextPutAll: ').';
			cr].
	aStream cr
! !

!MDMc1LoadScript methodsFor: 'writing' stamp: 'cwp 9/25/2009 14:50'!
writeTempsOn: aStream
	aStream
		nextPutAll: '| versions repositories |';
		cr;
		cr! !

!MDMc1LoadScript methodsFor: 'writing' stamp: 'cwp 9/27/2009 23:33'!
writeVersionsOn: aStream
	aStream
		nextPutAll: 'versions := Array new: ';
		print: target children size;
		nextPut: $.;
		cr.
	target children doWithIndex: 
		[:child :index |
		aStream
			nextPutAll: 'versions at: ';
			print: index;
			nextPutAll: ' put: ((repositories at: ';
			print: (self indexOfRepositoryFor: child);
			nextPutAll: ') versionFromFileNamed: ''';
			nextPutAll: child name;
			nextPutAll: ''').';
			cr].
	aStream cr.
			
			 	! !

Object subclass: #MDMc1RepositorySource
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-MC1'!

!MDMc1RepositorySource class methodsFor: 'as yet unclassified' stamp: 'cwp 9/15/2009 09:22'!
for: aRepository
	^ self new setRepository: aRepository! !

!MDMc1RepositorySource methodsFor: 'as yet unclassified' stamp: 'cwp 9/16/2009 22:02'!
addAllJobsTo: context forFilename: aString resultDo: aBlock
	| result |
	result := context temp: aString.
	MDGetVersionJob new
		repository: repository;
		filename: aString;
		path: result; 
		addToBuild: context.
	aBlock value: result! !

!MDMc1RepositorySource methodsFor: 'as yet unclassified' stamp: 'cwp 9/25/2009 13:39'!
repository
	^ repository! !

!MDMc1RepositorySource methodsFor: 'as yet unclassified' stamp: 'cwp 9/15/2009 09:22'!
setRepository: aRepository
	repository := aRepository! !

MDWriteScriptJob subclass: #MDExtractMczJob
	instanceVariableNames: 'mcz'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-MC1'!

!MDExtractMczJob methodsFor: 'accessing' stamp: 'cwp 12/23/2008 13:29'!
mcz
	^ mcz! !

!MDExtractMczJob methodsFor: 'accessing' stamp: 'cwp 9/16/2009 23:09'!
mcz: anObject
	mcz := anObject ! !

!MDExtractMczJob methodsFor: 'as yet unclassified' stamp: 'cwp 9/17/2009 00:02'!
requires
	^ Set 
		with: self path parent
		with: self mcz! !

!MDExtractMczJob methodsFor: 'running' stamp: 'cwp 9/16/2009 23:57'!
writeOn: aStream
	| zip member |
	zip := ZipArchive new readFrom: self mcz path asString.
	member := zip memberNamed: 'snapshot/source.st'.
	member extractTo: aStream.
	! !

MDProduct subclass: #MDMc1RepositoryProduct
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-MC1'!

MDMc1RepositoryProduct subclass: #MDMc1LatestProduct
	instanceVariableNames: 'packageName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-MC1'!

!MDMc1LatestProduct class methodsFor: 'as yet unclassified' stamp: 'cwp 9/27/2009 15:07'!
packageName: aString repository: aRepository
	^ self new
		packageName: aString;
		repository: aRepository;
		yourself
		! !

!MDMc1LatestProduct methodsFor: 'fetching' stamp: 'cwp 9/27/2009 23:27'!
latestVersion
	| choices |
	choices := self packageVersions.
	choices sort: [:a :b | a third <= b third].
	^ choices last! !

!MDMc1LatestProduct methodsFor: 'accessing' stamp: 'cwp 9/27/2009 15:14'!
packageName
	^ packageName! !

!MDMc1LatestProduct methodsFor: 'accessing' stamp: 'cwp 9/27/2009 15:14'!
packageName: anObject
	packageName := anObject! !

!MDMc1LatestProduct methodsFor: 'fetching' stamp: 'cwp 9/27/2009 23:28'!
packageVersions
	^ self allVersions select: [ :ea | ea first = packageName ]! !

!MDMc1LatestProduct methodsFor: 'as yet unclassified' stamp: 'cwp 9/27/2009 23:34'!
specifyOn: targets
	targets version
		name: self latestVersion last;
		source: (targets mc1RepositorySource: repository)! !

!MDMc1RepositoryProduct methodsFor: 'fetching' stamp: 'cwp 9/27/2009 23:24'!
allVersions
	| versions |
	versions := repository readableFileNames collect: [ :each | self parseFilename: each ].
	^ versions select: [ :each | (each at: 3) isNumber ]! !

!MDMc1RepositoryProduct methodsFor: 'fetching' stamp: 'cwp 9/27/2009 23:25'!
parseFilename: filename 
	| name |
	name := filename last isDigit
		ifTrue: [filename]
		ifFalse: [(filename copyUpToLast: $.) copyUpTo: $(].
	^ Array 
		with: (name copyUpToLast: $-)
		with: ((name copyAfterLast: $-) copyUpTo: $.)
		with: ((name copyAfterLast: $-) copyAfter: $.) asInteger
		with: filename! !

!MDMc1RepositoryProduct methodsFor: 'accessing' stamp: 'cwp 9/27/2009 23:24'!
repository
	^ repository! !

!MDMc1RepositoryProduct methodsFor: 'accessing' stamp: 'cwp 9/27/2009 23:24'!
repository: anObject
	repository := anObject! !

MDMc1RepositoryProduct subclass: #MDUmbrellaProduct
	instanceVariableNames: 'packageName authorInitials ordinal customizer versionNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-MC1'!

!MDUmbrellaProduct methodsFor: 'accessing' stamp: 'cwp 9/1/2009 20:24'!
authorInitials
	^ authorInitials! !

!MDUmbrellaProduct methodsFor: 'accessing' stamp: 'cwp 9/1/2009 20:24'!
authorInitials: anObject
	authorInitials := anObject! !

!MDUmbrellaProduct methodsFor: 'fetching' stamp: 'cwp 9/1/2009 22:16'!
chosenUmbrellaSpec
	| choices |
	choices := self umbrellaSpecs.
	authorInitials ifNotNil: [choices := choices select: [:ea | ea second = authorInitials]].
	ordinal ifNotNil: [choices := choices select: [:ea | ea third = ordinal]].
	choices sort: [:a :b | a third <= b third].
	^ choices last! !

!MDUmbrellaProduct methodsFor: 'customizing' stamp: 'cwp 9/17/2009 23:21'!
customize: names
	^ (customizer ifNil: [^ names]) value: names.
	! !

!MDUmbrellaProduct methodsFor: 'customizing' stamp: 'cwp 9/17/2009 23:22'!
customizeWith: aBlock
	customizer := aBlock! !

!MDUmbrellaProduct methodsFor: 'accessing' stamp: 'cwp 9/22/2009 22:40'!
customizedVersionNames
	^ self customize: self versionNames! !

!MDUmbrellaProduct methodsFor: 'customizing' stamp: 'cwp 9/19/2009 23:34'!
dependencyPackageNames: packageNames
	self customizeWith:
		[:names |
		packageNames collect:
			[:packageName | 
			names 
				detect: [:versionName | versionName beginsWith: packageName]
				ifNone: [self error: packageName, ' not found']]]! !

!MDUmbrellaProduct methodsFor: 'fetching' stamp: 'cwp 9/22/2009 21:15'!
fetchVersionNames
	| spec dependencies |
	spec := self chosenUmbrellaSpec.
	repository 
		versionReaderForFileNamed: spec last 
		do: [:r | dependencies := r dependencies].
	^ dependencies collect: [:ea | ea versionInfo name]! !

!MDUmbrellaProduct methodsFor: 'fetching' stamp: 'cwp 9/1/2009 20:41'!
hasOrdinalSpec
	^ ordinal notNil! !

!MDUmbrellaProduct methodsFor: 'accessing' stamp: 'cwp 9/1/2009 20:24'!
ordinal
	^ ordinal! !

!MDUmbrellaProduct methodsFor: 'accessing' stamp: 'cwp 9/1/2009 20:24'!
ordinal: anObject
	ordinal := anObject! !

!MDUmbrellaProduct methodsFor: 'accessing' stamp: 'cwp 9/1/2009 20:25'!
packageName
	^ packageName! !

!MDUmbrellaProduct methodsFor: 'accessing' stamp: 'cwp 9/1/2009 20:23'!
packageName: aString
	packageName := aString ! !

!MDUmbrellaProduct methodsFor: 'specifying' stamp: 'cwp 9/17/2009 23:18'!
specifyOn: targets
	(self customize: self versionFilenames) do:
		[:filename |
		targets version
			name: filename;
			source: (targets mc1RepositorySource: repository)]! !

!MDUmbrellaProduct methodsFor: 'fetching' stamp: 'cwp 9/1/2009 20:34'!
umbrellaSpecs
	^ self allVersions select: [ :ea | ea first = packageName ]! !

!MDUmbrellaProduct methodsFor: 'fetching' stamp: 'cwp 9/1/2009 21:13'!
umbrellaVersion
	| spec dependencies |
	spec := self chosenUmbrellaSpec.
	dependencies := repository 
		versionReaderForFileNamed: spec last 
		do: [:r | r dependencies]! !

!MDUmbrellaProduct methodsFor: 'accessing' stamp: 'cwp 9/1/2009 20:33'!
use: aString
	| elements |
	elements := self parseFilename: aString.
	packageName := elements at: 1.
	authorInitials := elements at: 2.
	ordinal := elements at: 3.! !

!MDUmbrellaProduct methodsFor: 'accessing' stamp: 'cwp 9/15/2009 09:19'!
versionFilenames
	^ self versionNames collect: [:ea | ea, '.mcz']! !

!MDUmbrellaProduct methodsFor: 'accessing' stamp: 'cwp 9/22/2009 21:15'!
versionNames
	^ versionNames ifNil: [versionNames := self fetchVersionNames]! !

MDTarget subclass: #MDMc1LoaderTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-MC1'!

!MDMc1LoaderTarget methodsFor: 'build' stamp: 'cwp 9/25/2009 11:00'!
addAllJobsTo: context scriptsDo: aBlock 
	| script |
	script := context temp: 'mc1-load.st'.
	self addJobTo: context at: script.
	aBlock value: script! !

!MDMc1LoaderTarget methodsFor: 'build' stamp: 'cwp 9/25/2009 13:42'!
addJobTo: context at: script
	MDWriteFileJob new
		source: self loadScript;
		dest: script;
		addToBuild: context.
	! !

!MDMc1LoaderTarget methodsFor: 'build' stamp: 'cwp 9/25/2009 10:59'!
addJobsTo: context
	self 
		addJobTo: context 
		at: (context resolve: 'mc-load.st')! !

!MDMc1LoaderTarget methodsFor: 'accessing' stamp: 'cwp 9/25/2009 22:53'!
children
	^ children! !

!MDMc1LoaderTarget methodsFor: 'accessing' stamp: 'cwp 9/25/2009 14:52'!
loadScript
	^ (MDMc1LoadScript for: self) script! !

MDTarget subclass: #MDMc1VersionTarget
	instanceVariableNames: 'name source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-MC1'!

!MDMc1VersionTarget methodsFor: 'jobs' stamp: 'cwp 9/20/2009 12:18'!
addAllJobsTo: context scriptsDo: aBlock 
	"This is used to create a script to filein to an image."

	| path |
	source 
		addAllJobsTo: context
		forFilename: name
		resultDo: 
			[ :mcz | 
			path := context temp: self scriptName.
			MDExtractMczJob new
				mcz: mcz;
				path: path;
				addToBuild: context.
			aBlock value: path ]! !

!MDMc1VersionTarget methodsFor: 'jobs' stamp: 'cwp 9/20/2009 12:25'!
addJobsTo: context
	"This is used to create a fileout of the version in a directory."

	| path |
	source 
		addAllJobsTo: context
		forFilename: name
		resultDo: 
			[ :mcz | 
			path := context resolve: self scriptName.
			MDExtractMczJob new
				mcz: mcz;
				path: path;
				addToBuild: context]! !

!MDMc1VersionTarget methodsFor: 'accessing' stamp: 'cwp 9/15/2009 09:13'!
name
	^ name! !

!MDMc1VersionTarget methodsFor: 'accessing' stamp: 'cwp 9/15/2009 09:13'!
name: anObject
	name := anObject! !

!MDMc1VersionTarget methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2009 23:45'!
printOn: aStream
	aStream 
		nextPutAll: 'MC1Version(';
		nextPutAll: name;
		nextPut: $)! !

!MDMc1VersionTarget methodsFor: 'accessing' stamp: 'cwp 9/16/2009 22:07'!
scriptName
	^ (name asPath, 'st') asString! !

!MDMc1VersionTarget methodsFor: 'accessing' stamp: 'cwp 9/15/2009 12:41'!
scriptNameWithIndex: anInteger
	String streamContents:
		[:out |
		anInteger printOn: out.
		out nextPut: $-.
		out nextPutAll: name.
		out nextPutAll: '.st']! !

!MDMc1VersionTarget methodsFor: 'accessing' stamp: 'cwp 9/15/2009 09:13'!
source
	^ source! !

!MDMc1VersionTarget methodsFor: 'accessing' stamp: 'cwp 9/15/2009 09:13'!
source: anObject
	source := anObject! !
